var fs     = require('fs');
var path   = require('path');
var rimraf = require('rimraf');

// Creates an HTML page out of a documentation object, and writes it to disk.
// tree: a component object generated by Super.parse().
module.exports = function(data) {
  // Get a Handlebars instance
  var handlebars = this.options.handlebars || require('handlebars');

  // Fetch template code
  var fileData = fs.readFileSync(this.options.template);

  // Compile it into Handlebars templates
  var template = handlebars.compile(fileData.toString(), {noEscape: true});

  // Render a template with the component's data and write it to disk
  var output = '';

  // Catch Handlebars errors, because they won't show up in the Gulp console
  try {
    output = template(data);
  }
  catch(e) {
    throw new Error('Handlebars error: ' + e.message);
  }

  return output;
}
